Rev 3407 Rev 3410
1 #!/usr/bin/env bash 1 #!/usr/bin/env bash
2   2  
3 [[ $# -ne 1 ]] && echo "Usage: ./sync.sh /path/to/folder" && exit 1 3 [[ $# -ne 1 ]] && echo "Usage: ./sync.sh /path/to/folder" && exit 1
4   4  
5 # Redirect stdout ( > ) into a named pipe ( >() ) running "tee" 5 # Redirect stdout ( > ) into a named pipe ( >() ) running "tee"
6 exec > >(tee "$1"/logfile.txt) 6 exec > >(tee "$1"/logfile.txt)
7   7  
8 # Also redirect stderr 8 # Also redirect stderr
9 exec 2>&1 9 exec 2>&1
10   10  
11 FREQUENCY=60 11 FREQUENCY=180
12   12  
13 TIDYUP="$(pwd)/tidyup.sh" 13 TIDYUP="$(pwd)/tidyup.sh"
14 RSYNC="$(pwd)/upload.sh" 14 RSYNC="$(pwd)/upload.sh"
15   15  
16 DEFAULT="\033[00m" 16 DEFAULT="\033[00m"
17 RED="\033[01;31m" 17 RED="\033[01;31m"
18 BLUE="\033[01;36m" 18 BLUE="\033[01;36m"
19   19  
20 function info() { 20 function info() {
21 echo -en "$BLUE"; echo -n $1; echo -e "$DEFAULT" 21 echo -en "$BLUE"; echo -n $1; echo -e "$DEFAULT"
22 } 22 }
23   23  
24 function error() { 24 function error() {
25 echo -en "$RED"; echo -n $1; echo -e "$DEFAULT" 25 echo -en "$RED"; echo -n $1; echo -e "$DEFAULT"
26 } 26 }
27   27  
28 function syncdir() { 28 function syncdir() {
29 EXIT=1 29 EXIT=1
30 i=1 30 i=1
31 while [ $EXIT -ne 0 ]; do 31 # while [ $EXIT -ne 0 ]; do
32 info "Trying to sync $1, try number $i" 32 info "Trying to sync $1, try number $i"
33 "$RSYNC" "$1" 33 "$RSYNC" "$1"
34 EXIT=$? 34 EXIT=$?
35 [ $EXIT -ne 0 ] && error "sync failed" 35 [ $EXIT -ne 0 ] && error "sync failed"
36 let i++ 36 let i++
37 done 37 # done
38 return $EXIT 38 return $EXIT
39 } 39 }
40   40  
41 # Sort files 41 # Sort files
42 # Mask 42 # Mask
43 function tidyup() { 43 function tidyup() {
44 info "sorting $1" 44 info "sorting $1"
45 "$TIDYUP" $1 45 "$TIDYUP" $1
46 if [ "$?" -ne 0 ]; then 46 if [ "$?" -ne 0 ]; then
47 error "sorting failed, please send logfile.txt to toxygen1@gmail.com" 47 error "sorting failed, please send logfile.txt to toxygen1@gmail.com"
48 return 1 48 return 1
49 fi 49 fi
50 return 0 50 return 0
51 } 51 }
52   52  
53 # Test public key authentication 53 # Test public key authentication
54 function sshtest() { 54 function sshtest() {
55 ./test.sh 55 ./test.sh
56 if [ "$?" -eq 0 ]; then 56 if [ "$?" -eq 0 ]; then
57 info "Authentication works" 57 info "Authentication works"
58 return 0 58 return 0
59 else 59 else
60 error "Authentication does not work" 60 error "Authentication does not work"
61 return 1 61 return 1
62 fi 62 fi
63 } 63 }
64   64  
65 # Check if we can connect, otherwise terminate 65 # Check if we can connect, otherwise terminate
66 sshtest || exit 1 66 sshtest || exit 1
67   67  
68 # Change working directory 68 # Change working directory
69 cd $1 69 cd $1
70   70  
-   71  
71 # reset counter 72 # reset counter
72 HOURCOUNT=24 73 HOURCOUNT=24
73   74  
74 # Periodically tidy up and do incremental sync 75 # Periodically tidy up and do incremental sync
75 while : 76 while :
76 do 77 do
77 # start timer 78 # start timer
78 start_time=`date +%s` 79 start_time=`date +%s`
79 80
80 # sort 81 # sort
81 tidyup $1 || error "Sort failed, please send logfile.txt to toxygen1@gmail.com" 82 tidyup $1 || error "Sort failed, please send logfile.txt to toxygen1@gmail.com"
82 83
83 # increase counter every hour 84 # increase counter every hour
84 # if 24 hour mark is hit, do daily sync 85 # if 24 hour mark is hit, do daily sync
85 if [[ "$HOURCOUNT" -eq 24 ]] 86 if [[ "$HOURCOUNT" -eq 24 ]]
86 then 87 then
87 info "Doing complete sync" 88 info "Doing complete sync"
88 syncdir . 89 syncdir .
89 HOURCOUNT=0 90 HOURCOUNT=0
90 fi 91 fi
91 92
92 if [ -f "$1"/LAST ] 93 if [ -f "$1"/LAST ]
93 then 94 then
94 # next line is important for the first run of the loop 95 # next line is important for the first run of the loop
95 read LAST < "$1"/LAST 96 read LAST < "$1"/LAST
96 97
97 let HOURCOUNT++ 98 let HOURCOUNT++
98   99  
99 # read last processed day 100 # read last processed day
100 OLD="$LAST" 101 OLD="$LAST"
101 read LAST < "$1"/LAST 102 read LAST < "$1"/LAST
102   103  
103 # sync last updated folders 104 # sync last updated folders
104 syncdir ./audio/"$LAST" 105 syncdir ./audio/"$LAST"
105 syncdir ./capture/"$LAST" 106 syncdir ./capture/"$LAST"
106 syncdir ./data/"$LAST" 107 syncdir ./data/"$LAST"
107   108  
108 # days changed, sync yesterday too 109 # days changed, sync yesterday too
109 [[ "$LAST" != "$OLD" ]] && info "syncing yesterday" && syncdir "$OLD" 110 [[ "$LAST" != "$OLD" ]] && info "syncing yesterday" && syncdir "$OLD"
110   111  
111 tail -n 1000 "$1"/logfile.txt > "$1"/tmp.txt 112 tail -n 1000 "$1"/logfile.txt > "$1"/tmp.txt
112 mv "$1"/tmp.txt "$1"/logfile.txt 113 mv "$1"/tmp.txt "$1"/logfile.txt
113 fi 114 fi
114 115
115 # end timer 116 # end timer
116 end_time=`date +%s` 117 end_time=`date +%s`
117 ELAPSED=`expr $end_time - $start_time` 118 ELAPSED=`expr $end_time - $start_time`
118 info "execution time was $ELAPSED s" 119 info "execution time was $ELAPSED s"
-   120
-   121 date
119   122
120 # if last sync took less than TIME, sleep to make up 1 hour 123 # if last sync took less than TIME, sleep to make up 1 hour
121 [[ $ELAPSED -lt $FREQUENCY ]] && sleep `expr $FREQUENCY - $ELAPSED` 124 # [[ $ELAPSED -lt $FREQUENCY ]] && sleep `expr $FREQUENCY - $ELAPSED`
-   125 sleep $FREQUENCY
122 done 126 done
123 127